#include <iostream.h>
#include <fstream.h>

/** 
 * Convert a sprite multicolor byte by inverting SMC1 with SMC2
 * 
 * @param value the value to convert
 * @return the converted value
 */
short int conv(short int value) {
  short int res;
  short int b1;
  
  b1=value & 0xC0;
  if (b1==0x40) b1=0x80;
  else if (b1==0x80) b1=0x40;
  res=b1;
  
  b1=value & 0x30;
  if (b1==0x20) b1=0x10;
  else if (b1==0x10) b1=0x20;  
  res|=b1;
  
  b1=value & 0x0C;
  if (b1==0x04) b1=0x08;
  else if (b1==0x08) b1=0x04;  
  res|=b1;
  
  b1=value & 0x03;
  if (b1==0x02) b1=0x01;
  else if (b1==0x01) b1=0x02;  
  res|=b1;   
  
  return res;
}


int main(int argc, char** argv) {
  short int value;
  char ch;
 
  if (argc<3) {
    cout << "Usage: inv input_file output_file\n";
    return 1;
  }
  
  ifstream fi(argv[1], ios::in);
  ofstream fo(argv[2], ios::out);
  
  while (fi.get(ch)) {
   value=(short int)ch;
   fo.put(conv(value)); 
  }    
  fo.flush();
  fo.close();
  fi.close();
}


