; manage I/O routines


score:                           ; actual score
  .byte $00, $00, $00

hiScore:                         ; high score
  .byte $00, $00, $00

bestScore:                       ; 6 best scores
  .byte $00, $50, $10            ; high
  .byte $00, $40, $10  
  .byte $00, $30, $10
  .byte $00, $20, $10
  .byte $00, $10, $10
  .byte $00, $00, $10            ; low

bestName:                        ; 6 best names 
  .byte "ICE TEAM        "       ; high
  .byte " ICE TEAM       "
  .byte "  ICE TEAM      "
  .byte "   ICE TEAM     "
  .byte "    ICE TEAM    "
  .byte "     ICE TEAM   "       ; low     
  
txtBestScore:                    ; txt of the best score 
  .byte "1                          ",0  
  .byte "2                          ",0
  .byte "3                          ",0  
  .byte "4                          ",0  
  .byte "5                          ",0  
  .byte "6                          ",0  
  
;=================================
; Clear the screen by removing
; actors and rewrite all
;=================================
clearScreen:
      jsr  removeActor            ; remove all actor
      jsr  drawSprites            ; be sure they are not now visible
      
      jsr  erase2Screen           ; clearing the screen with color
      jsr  writeGameTitle
      jsr  writeScoreTitle
      rts


;==================================
; Get Joystick movement
;==================================
getJoystick:
      lda  #$FF
      sta  $DC00
      lda  $DC00
      eor  #$FF
      sta  joystick
      rts       
      
;=================================
; Write win string
;=================================
writeWin:
      lda  #<(SCREEN1+11*40+4)
      sta  CTO
      lda  #>(SCREEN1+11*40+4)
      sta  CTO+1
      
      lda  #<(SCREEN2+11*40+4)
      sta  CTO1
      lda  #>(SCREEN2+11*40+4)
      sta  CTO1+1      
      
      lda  #<Swin
      sta  CFROM
      lda  #>Swin
      sta  CFROM+1
      
      jsr  putString      
      rts
Swin:
  .byte "WELL DONE SARA: YOU ARE THE BEST",0
  

;=================================
; Write title of game
;=================================
writeGameTitle:
      lda  #<(SCREEN1+24*40+1)
      sta  CTO
      lda  #>(SCREEN1+24*40+1)
      sta  CTO+1
      
      lda  #<(SCREEN2+24*40+1)
      sta  CTO1
      lda  #>(SCREEN2+24*40+1)
      sta  CTO1+1      
      
      lda  #<Sname
      sta  CFROM
      lda  #>Sname
      sta  CFROM+1
      
      jsr  putString             ; put the name of the game 
      rts
Sname:
  .byte "LITTLE SARA SISTER 2 BY ICE TEAM 2005",0

;=================================
; give bonus: time*25 points
;=================================
giveBonus:
      pha                      
      lda  #<(SCREEN1+13*40+10)
      sta  CTO
      lda  #>(SCREEN1+13*40+10)
      sta  CTO+1
      
      lda  #<(SCREEN2+13*40+10)
      sta  CTO1
      lda  #>(SCREEN2+13*40+10)
      sta  CTO1+1      
      
      lda  #<Sbonus
      sta  CFROM
      lda  #>Sbonus
      sta  CFROM+1
      
      jsr  putString      
      pla

      tax
loopBonus:
      stx  temp3
      lda  #$20
      jsr  addScore               ; add the score
      jsr  testScore              ; test if this is the high score
      jsr  writeScore
      jsr  waitIRQ
      ldx  temp3
      dex
      bne  loopBonus

      rts

Sbonus:
  .byte "BONUS:  TIME*20",0


;=================================
; Write fire string
;=================================
writeFire:
      lda  #<(SCREEN1+13*40+15)
      sta  CTO
      lda  #>(SCREEN1+13*40+15)
      sta  CTO+1
      
      lda  #<(SCREEN2+13*40+15)
      sta  CTO1
      lda  #>(SCREEN2+13*40+15)
      sta  CTO1+1      
      
      lda  #<Sfire
      sta  CFROM
      lda  #>Sfire
      sta  CFROM+1
      
      jsr  putString      
      rts

Sfire:
  .byte "PRESS FIRE",0
  

;=================================
; Write get ready string
;=================================
writeGetReady:
      lda  #<(SCREEN1+13*40+9)
      sta  CTO
      lda  #>(SCREEN1+13*40+9)
      sta  CTO+1
      
      lda  #<(SCREEN2+13*40+9)
      sta  CTO1
      lda  #>(SCREEN2+13*40+9)
      sta  CTO1+1      
      
      lda  #<Sgetr
      sta  CFROM
      lda  #>Sgetr
      sta  CFROM+1
      
      jsr  putString      
      rts

Sgetr:
  .byte "      GET READY...",0    

;=================================
; Write game over string
;=================================
writeGameOver:
      lda  #<(SCREEN1+11*40+15)
      sta  CTO
      lda  #>(SCREEN1+11*40+15)
      sta  CTO+1
      
      lda  #<(SCREEN2+11*40+15)
      sta  CTO1
      lda  #>(SCREEN2+11*40+15)
      sta  CTO1+1      
      
      lda  #<Sover
      sta  CFROM
      lda  #>Sover
      sta  CFROM+1
      
      jsr  putString       
      rts

Sover:
  .byte "GAME OVER",0

;=================================
; Write the title of score
;=================================
writeScoreTitle:
      lda  #<(SCREEN1+0*40+3)
      sta  CTO
      lda  #>(SCREEN1+0*40+3)
      sta  CTO+1
      
      lda  #<(SCREEN2+0*40+3)
      sta  CTO1
      lda  #>(SCREEN2+0*40+3)
      sta  CTO1+1      
      
      lda  #<Sscore
      sta  CFROM
      lda  #>Sscore
      sta  CFROM+1
      
      jsr  putString             ; put the name of the game      
      rts
Sscore:
  .byte "SCORE   BONUS    LIVES  LEVEL  TIME             ",CH_DIAM1+64,0

;=================================
; Write the score
;=================================
writeScore:
      lda  bonus                  ; write the number of bonus
      jsr  atoax
      stx  $400+40+14
      sta  $400+40+15
      stx  $8400+40+14
      sta  $8400+40+15

      lda  lifes
      ora  #$30
      sta  $400+40+22
      sta  $8400+40+22

      lda  level
      clc
      adc  #49                    ; add '1'
      sta  $400+40+29
      sta  $8400+40+29

      lda  time                   ; write the time
      jsr  atoax
      stx  $400+40+35
      sta  $400+40+36
      stx  $8400+40+35
      sta  $8400+40+36

      ldx  #0
      jsr  writePoints
      ldx  #3
      jsr  writePoints

      rts

;=================================
; write score
; x=0/3 0 for score, 3 for highscore
;=================================
writePoints:
      ldy  #0

      lda  #$2A                   ; this is the low address for score ($42A)
      cpx  #3
      bne  skipws

      lda  #$52                   ; this is the high address for hiscore ($452)
skipws:
      sta  wra1+1                 ; change low address as needed
      sta  wra11+1
      sta  wra2+1
      sta  wra21+1
      
loopws:
      lda  score,x
      pha
      lsr
      lsr
      lsr
      lsr
      ora  #$30
wra1:
      sta  $400+40+2,y
wra11:      
      sta  $8400+40+2,y
      iny
      pla
      and  #$0F
      ora  #$30
wra2:
      sta  $400+40+3,y
wra21:
      sta  $8400+40+3,y      
      inx
      iny
      cpy  #6
      bne  loopws
      rts

;=================================
; add points to score
; A=point to add
;=================================
addScore:
      stx  temp3
      ldx  #2
      ;ldy  #0                     ; clear carry indicator
      sed                         ; decimal mode
      clc
      adc  score,x
      sta  score,x
      bcc  exitscore

      ;iny                         ; carry indicator
      dex
      lda  #0
      adc  score,x
      sta  score,x
      bcc  exitscore

      dex
      lda  #0
      adc  score,x
      sta  score,x
exitscore:
      cld                         ; normal mode

      ;cpy  #0                     ; test carry indicator
      ;beq  skipAS

      ;lda  score+1                ; read middle of score
      ;and  #$3F
      ;cmp  #$40
      ;bne  skipAS                 ; if $40, we have reach another 4000 points

      ;jsr  incLife                ; give another life
skipAS:
      ldx  temp3
      rts

;=================================
; Test if this score must be the
; hiscore
;=================================
testScore:
                                  ; test if we have a new highscore
      lda  score
      cmp  hiScore
      bcc  notHS
      bne  setHS

      lda  score+1
      cmp  hiScore+1
      bcc  notHS
      bne  setHS

      lda  score+2
      cmp  hiScore+2
      bcc  notHS
      bne  setHS

notHS:
      rts

setHS:                             ; copy the score to hiscore
      ldx  #3
setHS_:
      lda  score-1,x
      sta  score+2,x
      dex
      bne  setHS_
      beq  notHS

;=================================
; input a=$12 output x= $31 "1" a= $32 "2"
;=================================
atoax:
      pha                      ; save A for lo-nibble fetch
      lsr
      lsr
      lsr
      lsr
      ora  #$30
      tax
      pla                      ;lo-nibble fetch
      and  #$0F
      ora  #$30
      rts
         
;================================
; Put a string in both memory map
; CTO, CTO+1, CFROM are to be setted
;================================      
putString:  
      ldx  #0 
loopWGT:      
      lda  (CFROM),x             ; read the char 
      beq  exitWGT
      
      cmp  #64
      bmi  skipAj
      
      sec
      sbc  #64                   ; CHR$ to Screen
skipAj:      
      
      sta  (CTO),x               ; copy in first place
      sta  (CTO1),x              ; copy in second place
      inc  CFROM
      bne  skF
      inc  CFROM+1  
skF:            
      inc  CTO
      inc  CTO1
      bne  skT
      inc  CTO+1  
      inc  CTO1+1
skT:      

      jmp  loopWGT
exitWGT:
      rts     
      
      
;================================
; Put a string in both memory map
; CTO, CFROM are to be setted
;================================      
put1String:  
      ldx  #0 
loopWGT1:      
      lda  (CFROM),x             ; read the char 
      beq  exitWGT1
      
      cmp  #64
      bmi  skipAj1
      
      sec
      sbc  #64                   ; CHR$ to Screen
skipAj1:      
      
      sta  (CTO),x               ; copy in first place
      
      inc  CFROM
      bne  skF1
      inc  CFROM+1  
skF1:            
      inc  CTO
      bne  skT1
      inc  CTO+1  
skT1:      

      jmp  loopWGT1
exitWGT1:
      rts
            
;================================
; Clear the screen in 1° memory
; map
;================================      
erase1Screen:      
      lda  #1
      jsr  SCREEN                ; clearing the screen with color in page 0
           
      lda  #1
      sta  memMap
      lda  #6
      sta  xScroll
      jsr  flipBank
      rts
      
;================================
; Clear the screen in both memory
; map
;================================      
erase2Screen:      
      jsr  erase1Screen
      
      ldx  #1                    ; clear in map 2 
      lda  #32
loopCS:
N     SET 0
      REPEAT 25       
      sta  SCREEN2+N*40,x
N     SET  N+1
      REPEND   
      inx
      cpx  #40
      bne  loopCS      
      rts      
      
;================================
; Clear the screen in bank 3 map
;================================      
erase3Screen:                  
      ldx  #0
      lda  #32
loopCS3:
N     SET 12
      REPEAT 13        
      sta  SCREEN3+N*40,x
N     SET  N+1
      REPEND   
      inx
      cpx  #40
      bne  loopCS3      
      rts      
      
;=================================
; Test if this score must be in the
; best hiscore
;=================================
testBestScore:
                                  ; test if we have a new best highscore
      lda  score
      cmp  bestScore+15
      bcc  notBS
      bne  isBS

      lda  score+1
      cmp  bestScore+16
      bcc  notBS      
      bne  isBS

      lda  score+2
      cmp  bestScore+17
      bcc  notBS
isBS:
      sec                        ; enable carry as this is a best score
      rts
 
notBS:
      clc                        ; clear carry as this is not a best score    
      rts

;================================
; generate the txt score to show
;================================      
generateTxtScore:
      lda  #<bestScore           ; point source to best score
      sta  CFROM
      lda  #>bestScore
      sta  CFROM+1
      
      lda  #<(txtBestScore+2)    ; point des to best score text 
      sta  CTO
      lda  #>(txtBestScore+2)
      sta  CTO+1
      
                                 ; put the score to the right places 
      lda  #6
      sta  temp3    
      ldy  #00
      
loopCSc:            
      jsr  put1Score             ; put the 6 digits of the score
      jsr  put1Score
      jsr  put1Score                  
      
      lda  CTO                   ; move destination to the next row
      clc
      adc  #22
      sta  CTO
      bcc  sk2 
      inc  CTO+1   
sk2:
      dec  temp3
      bne  loopCSc
                                 ; copy the names 
      lda  #<bestName            ; point source to best score
      sta  CFROM
      lda  #>bestName
      sta  CFROM+1
      
      lda  #<(txtBestScore+10)   ; point des to best score text for name
      sta  CTO
      lda  #>(txtBestScore+10)
      sta  CTO+1                
                                 ; put the names to the right places 
      lda  #6
      sta  temp3             
loopCN:
      
      ldy  #15
repCFT:
      lda  (CFROM),y
      sta  (CTO),y
      dey
      bpl  repCFT
    
      lda  CFROM                 ; move source to the next row
      clc
      adc  #16
      sta  CFROM
      bcc  sk3 
      inc  CFROM+1   
sk3:      
      lda  CTO                   ; move destination to the next row
      clc
      adc  #28
      sta  CTO
      bcc  sk4 
      inc  CTO+1   
sk4:            
      dec  temp3
      bne  loopCN
                 
      rts
      
;================================      
; calculate position of score
; give in x the position of the score
; (multiple of 3)
;================================
calculatePosition:
      ldx  #0

loopBSx:
      lda  score
      cmp  bestScore,x
      bcc  notBSx      
      bne  exitCP

      lda  score+1
      cmp  bestScore+1,x
      bcc  notBSx      
      bne  exitCP

      lda  score+2
      cmp  bestScore+2,x
      bcc  notBSx
                                 ; x = position
exitCP:
      rts
 
notBSx:
      inx
      inx
      inx
      jmp  loopBSx

;================================
; Shift the best score according 
; to position of x (multiple of 3)
; and insert user score
;================================
shiftBestScore:
      stx  dummy                 ; save x position for comparison
      ldy  #15

loopSBC:
      cpy  dummy
      beq  exitSBS
                                 ; put down the best score 
      lda  bestScore-3,y
      sta  bestScore,y
      lda  bestScore-2,y
      sta  bestScore+1,y
      lda  bestScore-1,y
      sta  bestScore+2,y

      dey
      dey
      dey
      jmp  loopSBC

exitSBS:
                                 ; put actual score to the new position
      lda  score
      sta  bestScore,x
      lda  score+1
      sta  bestScore+1,x
      lda  score+2
      sta  bestScore+2,x
      rts

      
;================================
; Read player name already 
; in right position
;================================      
readName: 
getC:
      jsr  SCNKEY
      jsr  GETIN
      cmp  #0
      beq  getC
      
      rts
      
;================================
; Put a score to the destination
;================================      
put1Score:      
      lda  CTO
      sta  ind1+1
      sta  ind2+1
      lda  CTO+1
      sta  ind1+2
      sta  ind2+2

      lda  (CFROM),y             ; transform a byte of score to 2 chars
      jsr  atoax
      
      iny
ind1:      
      sta  $0000,y
      dey
      txa      
ind2:      
      sta  $0000,y               ; put the score chars to the destination
      
      inc  CTO
      bne  skCT1      
      inc  CTO+1
skCT1:      
         
      iny       
      rts
      
;================================
; Write the table of score
;================================      
writeTableScore:
      lda  #<(SCREEN1+11*40+4)
      sta  CTO
      lda  #>(SCREEN1+11*40+4)
      sta  CTO+1

      lda  #<(SCREEN2+11*40+4)
      sta  CTO1
      lda  #>(SCREEN2+11*40+4)
      sta  CTO1+1
      
      lda  #<txtBestScore
      sta  CFROM
      lda  #>txtBestScore
      sta  CFROM+1
      
      lda  #5
      sta  temp3
repeatWT:      
      jsr  putString     
      
      lda  CTO
      clc
      adc  #40-27
      sta  CTO
      bcc  sk6
      inc  CTO+1  
sk6:

      lda  CTO1
      clc
      adc  #40-27
      sta  CTO1
      bcc  sk6_
      inc  CTO1+1  
sk6_:

      inc  CFROM
      bne  sk7
   
      inc  CFROM+1    
sk7      
      dec  temp3
      bpl  repeatWT
        
      rts      
            
;================================
; Wait for a fire action
; this avoit too fast pressing
;================================
waitFire:
releasefire
      jsr  getJoystick          ; check for already pressed fire
      and  #JOY_FIRE
      bne  releasefire
waitFire2                       ; wait a joystick fire action
      jsr  getJoystick
      and  #JOY_FIRE
      beq  waitFire2
      rts      
      
;================================
; Flip from bank 0 to 3
;================================      
vicBank3:                                 
      lda  $DD00      
      and  #$FC
      sta  $DD00
      rts

;================================                   
; Flip form bank 3 to 0
;================================
vicBank0:
      lda  $DD00
      ora  #$03
      sta  $DD00       
      rts
      
;================================
; Enable graphics
;================================      
enableGraphics:
                                 ; set pointer for graphics data
      lda  $d018
      ora  #$08
      and  #$f8
      sta  $d018             
                                 ; enable multicolor bitmap mode
      lda  $d011
      ora  #$20
      sta  $d011
      lda  $d016
      ora  #$10
      sta  $d016
      rts      

;================================
; Disable graphics
;================================            
disableGraphics:                 ; set pointer for text data
                                 ; enable text mode standard
      lda  $d011
      and  #$dF
      sta  $d011         

      lda  #31
      sta  $D018                 ; MCM char mode                                
      lda  #8
      sta  $d016  
      rts
      
;================================
; Put logo pic
;================================      
putLogo: 
      lda  #0                    ; set black screen     
      sta  53280
      sta  53281     
      
      ldx  #39
iscr1:
N     SET  0
      REPEAT 12
      lda  s2+N*40,x
      sta  $c400+N*40,x
      lda  s1+N*40,x
      sta  $d800+N*40,x
N     SET  N+1
      REPEND      
      dex
      bmi iscrdone1
      jmp iscr1
iscrdone1:     

      lda  #<s3
      sta  CFROM
      lda  #>s3
      sta  CFROM+1

      lda  #<$e000                 ; set position from where to paste
      sta  CTO
      lda  #>$e000
      sta  CTO+1

      ldx  #17
loopCopyE:
      ldy  #0                     ; copy the chars
loopCopy:
      lda  (CFROM),y
      sta  (CTO),y

      dey
      bne  loopCopy

      inc  CFROM+1
      inc  CTO+1
      dex
      bne  loopCopyE
      
      rts
     
s3:       
 .incbin "logo_bit.bin"
s2:
 .incbin "logo_color2.bin"
s1:
 .incbin "logo_color.bin"

  
;=================================
; Write Credits
;=================================
writeCredits:
      lda  #<(SCREEN3+17*40+0)
      sta  CTO
      lda  #>(SCREEN3+17*40+0)
      sta  CTO+1            
      
      lda  #<ST1
      sta  CFROM
      lda  #>ST1
      sta  CFROM+1
      
      jsr  put1String             ; put the name of the game    
      
      lda  #<(SCREEN3+18*40+0)
      sta  CTO
      lda  #>(SCREEN3+18*40+0)
      sta  CTO+1            
      
      lda  #<ST2
      sta  CFROM
      lda  #>ST2
      sta  CFROM+1
      
      jsr  put1String             ; put the name of the game      
      
      lda  #<(SCREEN3+19*40+0)
      sta  CTO
      lda  #>(SCREEN3+19*40+0)
      sta  CTO+1            
      
      lda  #<ST3
      sta  CFROM
      lda  #>ST3
      sta  CFROM+1
      
      jsr  put1String             ; put the name of the game          
      
      lda  #<(SCREEN3+20*40+0)
      sta  CTO
      lda  #>(SCREEN3+20*40+0)
      sta  CTO+1            
      
      lda  #<ST4
      sta  CFROM
      lda  #>ST4
      sta  CFROM+1
      
      jsr  put1String             ; put the name of the game     
      
      lda  #<(SCREEN3+21*40+0)
      sta  CTO
      lda  #>(SCREEN3+21*40+0)
      sta  CTO+1            
      
      lda  #<ST5
      sta  CFROM
      lda  #>ST5
      sta  CFROM+1
      
      jsr  put1String             ; put the name of the game        
      
      lda  #<(SCREEN3+24*40+13)
      sta  CTO
      lda  #>(SCREEN3+24*40+13)
      sta  CTO+1            
      
      lda  #<ST6
      sta  CFROM
      lda  #>ST6
      sta  CFROM+1
      
      jsr  put1String             ; put the name of the game          
      rts

ST1:  .byte "ICE00         CODE, GFX, SPRITE, EDITOR",0
ST2:  .byte "DUSTBIN                      MUSIC, SFX",0
ST3:  .byte "LUCA/FIRE            INTRO PICS & MUSIC",0
ST4:  .byte "ROBERTO/PAPPOSOFT                SPRITE",0
ST5:  .byte "IAN COOG/HOKUTOFORCE           CODE FIX",0
ST6:  .byte "ICE TEAM (C) 2005",0


;================================
; Make an animated color effect
;================================
colorEffect:
      ldx  #39
loopCEF:
      lda  colorA,x
      sta  $D800+17*40,x
      sta  $D800+18*40,x
      sta  $D800+19*40,x
      sta  $D800+20*40,x
      sta  $D800+21*40,x
      sta  $D800+24*40,x
      dex
      bpl  loopCEF

                                  ; rotate colors to left
      lda  colorA
      sta  dummy
                                           
      ldx  #1
      ldy  #0
loopSX:      
      lda  colorA,x
      sta  colorA,y
      inx
      iny
      cpx  #39
      bne  loopSX
      lda  dummy
      sta  colorA,y
      rts

; credits test color effect tables
colorA:
  .byte  1,  1,  1,  1,  1, 13, 13,  3,  3, 15
  .byte 15,  5,  5, 14, 14,  5,  5, 15, 15,  3
  .byte  3, 13, 13,  1,  1,  1,  1,  7,  7,  8
  .byte  8,  2,  2,  8,  8,  7,  7,  1,  1,  1
  
colorB:
  .byte $00
  
 
