; Little Sara Sister
; 4KB minigame
; by Stefano Tognon
; (C) 2004 Ice Team
; version 1.00

; Well, this game is dedicated to my "big Sara friend"
; This is my 8 game for C64 


; game is organizer as in EFNY source dissect:
; all done in a loop with only interrupt for syncronization
; map are done of block of 4x4 chars
; a screen is done by 5xN block and scroll goes from right to left
; color are the same for each block; we manage to change the color map every 4 columns
; many peace of code are rewrited expecially for fit the engine in low space

; each sprites are not expanded for reduce the code for manage them 
; and each actor use only 1 sprite with a fixed color

; Screen layout
;  0*8      
;  1*8   " SCORE, LIVES, POINTS, ..."
;  2*8
;  3*8   IRQ0: play music, set IRQ1, set graphics for scroll
;  4*8
;  ..    5 blocks  
;  23*8  IRQ1: set IRQ0, set graphics for title screen, let performs scrolling
;  24*8  "LITTLE SARA SISTER         by ICE TEAM 2004"

      processor 6502
      
RASTER0 =  82
RASTER1 =  242    

JOY_UP    = 1
JOY_DOWN  = 2
JOY_LEFT  = 4
JOY_RIGHT = 8
JOY_FIRE  = 16

STARTLIFES = 3        ; number of starting lifes
DIAMPOINT  = 37       ; points to add for a diamond
MONSPOINT  = $70      ; points for a monster killed

JUMPDEL   = 3         ; accelleration delay for y jump
JUMPSPEED = 256-5     ; speed of the y jump

MAPSIZE   =  39       ; size of the map  
MAXLEVEL  =  2
JUMPDELAY =  2        ; delay in frame for a jump after a jump   

BLIFE     =  $15      ; diamond to reach for one extra life

SCREEN     = $E536    ; clean the screen with color
SET_COOR   = $E50C    ; set x/y coord
STRING     = $AB1E    ; put a string

joystick   = $03      ; joystick values
jump       = $04      ; jump indicator for sprite 0 (1=jump)
accDel     = $05      ; acceleration delay for y movement
status     = $06      ; state: 0=live 1=killed 2=level pass
jumpDelay  = $07      ; if <>0 it is the delay for a jump
statFall   = $08      ; =1 if we cannot test again fot set flow in falling
dest       = $80      ; 80-82 address of destination character position
actMapAddr = $82      ; 82-83 actual map address
CFROM      = $82      ; 82-83 temp for copy
mapAddr    = $84      ; 84-85 map address for this level
cDest      = $86      ; 86-87 address of destination for color
CTO        = $86      ; 84-85 temp for copy
actBkColor = $88      ; actual color for background
GO         = $89      ; 1=go   
virtualD   = $90      ; virtual draw register for sprite
virtualX   = $91      ; virtual high bits register for sprite
temp1      = $92  
temp2      = $93
temp3      = $94

      
 ;org 2049
 ;dc.b $0b,$08,$e8,$03,$9e,"2061",0,0,0
 ;org 2061       
 
 org $1040
 incbin lss.bin
 
 org $196c 
 
      lda  #1
      jsr  SCREEN                 ; clearing the screen with color
      
      lda #14
      sta 53281
      
      ;lda  #1                     ; init music number 1 
      ;jsr  $1593
      
              
      ;lda  #$07
      ;sta  xScroll
      
; install custom chars
                                  ; transfer characters codes to 14336
      ldx  #00                                  
      ;lda  #254
      ;and  $DC0E
      ;sta  $DC0E
      sei
      
      ;lda  #251
      ;and  $01
      lda  #$33
      sta  $01
                                  ; set pointers
      lda  #$38
      sta  CTO+1
      lda  #$D0
      sta  CFROM+1
      lda  #0
      sta  CTO
      sta  CFROM
copy:                             ; copy the chars
      lda  (CFROM,x)
      sta  (CTO,x)
      inc  CFROM
      inc  CTO
      bne  copy
      inc  CFROM+1
      inc  CTO+1
      lda  CTO+1
      cmp  #$40
      bne  copy
                                  ; set pointers
      lda  #<char
      sta  CFROM
      lda  #>char
      sta  CFROM+1
      lda  #$00                   ; from char 64
      sta  CTO
      lda  #$3A
      sta  CTO+1
copy2:                            ; put the new chars
      lda  (CFROM,x)
      sta  (CTO,x)
      inc  CFROM
      inc  CTO
      bne  copy2

                                  ; restore pcr
      ;lda  #04
      ;ora  $01
      lda  #$37
      sta  $01
      cli
      ;lda  #01
      ;ora  $DC0E
      ;sta  $DC0E
                                  ; switch to new chars
      lda  #31
      sta  $D018
                                  ; MCM char mode
      ;lda  #$10
      ;ora  $D016
      ;sta  $D016
      
      ldx  #7
      stx  $D025                 ; set sprites common colors
      inx ; 8
      stx  $D022                 ; set common char multicolor
      inx ; 9
      stx  $D023
      stx  $D02A                 ; set color for sprite 3
      inx ;10
      stx  $D027                 ; set color for sprite 0
      stx  $D028                 ; set color for sprite 1
 
      ldx  #2
      stx  $D026
 
      ldx  #5;3
      stx  $D029                 ; set color for sprite 2

      
      ldx  #$FF                  ; set sprites multicolor
      stx  $D01C
      
      lda  #128
      sta  2040
      lda  #132
      sta  2041
      sta  2042     
      sta  2043
 
; install interrupt routine      
      sei
      lda  #<irqR0
      sta  $0314
      lda  #>irqR0
      sta  $0315
                                 ; disable cia interrupt
      ldx  #$00
      stx  $DC0E                 ; Control register A of CIA #1
      inx
      stx  $D01A                 ; IRQ mask register
      cli      
                                 ; use VIC interrupt 
      ;lda  #$01
      ;sta  $D019                  ; Interrupt indicator register
      stx  $D019                 ; Interrupt indicator register
      lda  #RASTER0
      sta  $D012                  ; Reading/Writing IRQ balance value
      lda  #$1B
      sta  $D011                  ; VIC control register
      
      
mainLoop:
      jsr  writeGameTitle 
      jsr  writeScoreTitle    
      jsr  writeFire             ; write press fire button for going
      
      lda  #1                     ; init music number 1 
      jsr  $1593
      
loopFire:                        ; attend a joystick fire action
      jsr  getJoystick
      and  #JOY_FIRE
      beq  loopFire
      
      
      lda  #0
      jsr  $1593

      lda  #STARTLIFES
      sta  lifes                 ; set intial lifes
      
      lda  #0                    ; start from level 1
      sta  level
      sta  score                 ; clear score 
      sta  score+1
      sta  score+2
      sta  bonus        
      
extLoop:
      jsr  removeActor           ; remove all actor
      jsr  drawSprites           ; be sure they are not now visible 
      lda  $D01E                 ; clear sprite collision check
      jsr  selectMap             ; select the map to show according to level  
      
      lda  #0                    ; init music number 0
      jsr  $1593
          
initialScroll:
      jsr  waitIRQ
      lda  #4
      jsr  madeScroll            ; show the fad-in scrolling
      lda  xMap
      cmp  #10                   ; that is of 10 blocks
      bcc  initialScroll
       
      lda  #1
      cmp  status                ; is killed?   
      bne  skipB
      
      lda  #0
      sta  bonus                 ; reset bonus if killed   
skipB:      
      
      lda  #0
      sta  jump
      sta  timeDl      
      sta  status
      sta  yActSpeed
      
      lda  #1
      cmp  status
      
      
      lda  #$99                  ; 99 seconds
      sta  time
            
      lda  #50                   ; put actor to his x/y position
      sta  xActLo
      lda  #00
      sta  xActHi
      lda  #168
      sta  yAct
      lda  #1                    ; and make it visible
      sta  actType     

intLoop
      jsr  getJoystick           ; get user joystick movements
      jsr  moveActor0            ; move Sara 
      jsr  moveMonster           ; move all the monsters

      jsr  waitIRQ               ; attend syncronization for madding the scroll
      
      jsr  checkScroll            
      jsr  madeScroll
      
      jsr  insertEnemy            ; insert one enemy if map says that             
      jsr  drawSprites            ; draw all the actors
      jsr  removeEnemy      
      
      jsr  ckeckDiamond          ; check if one diamond is taken by Sara
      jsr  checkEnemy            ; check Sara/monsters collision
      
      jsr  decTime               ; decrement the time
      jsr  testScore             ; test if this score is the highscore
      jsr  writeScore            ; write the score
  
      lda  status                ; test if screen is passed 
      cmp  #2                     
      beq  screenPassed                 
      
      lda  yAct                  ; test if we go under 3 chars from the bottom of the screen
      cmp  #172
      bcc  notToKill
     
      jsr  moveActor0            ; move Sara again (so spourious aligment will be avoided)
    
      lda  yAct                  ; test if we go under 3 chars from the bottom of the screen
      cmp  #172
      bcc  notToKill     
        
      lda  #1                    ; kill Sara (now I can't do otherwise...)
      sta  status
      
notToKill      
      lda  status
      cmp  #1                    ; is Sara killed?   
      bne  intLoop
      
      ldx  #40                   ; wait some frames as we are died
waitDied:      
      jsr  waitIRQ
      dex
      bne  waitDied      
      
      dec  lifes                 ; we lose one life
      beq  gameOver              ; game over if we reach 0
      
      jsr  clearScreen      
      jmp  extLoop
      
screenPassed:
      jsr  clearScreen
      
      lda  time
      jsr  giveBonus             ; give bonus according with this time
            
      inc  level                 ; go to next level
      lda  level                 ; check if we have win 
      cmp  #MAXLEVEL
      beq  win      
                  
      jmp  extLoop       
      
win: 
      jsr  clearScreen            
      jsr  writeWin              ; write win string

      jmp mainLoop
      
gameOver:
      jsr  clearScreen
      jsr  writeGameOver         ; write game over screen     
        
      jmp mainLoop      
      
     
;=================================
; Clear the screen by removing
; actors and rewrite all
;=================================      
clearScreen:       
      jsr  removeActor            ; remove all actor
      jsr  drawSprites            ; be sure they are not now visible 
         
      lda  #1
      jsr  SCREEN                 ; clearing the screen with color
      jsr  writeGameTitle 
      jsr  writeScoreTitle      
      rts

;=================================      
; Remove all actor from the screen      
;=================================      
removeActor:
      ldx  #7
      lda  #0
loopRA:      
      sta  actType,x
      dex
      bpl  loopRA      
      rts
      
;=================================
; Select map according to the level
;=================================      
selectMap:
      lda  level
      beq  level0

level1:      
      lda  #<MAP1
      sta  mapAddr
      lda  #>MAP1
      sta  mapAddr+1               
      
      lda  #0                     ; put black color for this 'cavern' screen   
      sta  $D020    
      sta  $D021
      beq  exitSelect
      
level0:
      lda  #14                    ; put light blue color for this 'open' screen   
      sta  $D020    
      sta  $D021
      lda  #<MAP0
      sta  mapAddr
      lda  #>MAP0
      sta  mapAddr+1       
      
exitSelect      
      lda  #0
      sta  xBlock
      sta  xMap 
      rts

      
;==================================
; Check dx collision
; we test the dx byte in middle 
; position of sprite
;==================================            
checkDx:
      lda  yAct,x
      sbc  #4;11                  ; this avoid bug in middle block
      jsr  commonCheck
      lda  (temp1),y              ; read the char under the actor
      cmp  #CHARLIMIT
      rts        
      
;==================================
; Check sx collision
; we test the sx byte in middle 
; position of sprite
;==================================            
checkSx:
      lda  yAct,x
      sbc  #4;11                  ; this avoid bug in middle block      
      jsr  commonCheck
      dey
      dey
      lda  (temp1),y              ; read the char under the actor
      cmp  #CHARLIMIT
      rts       

;==================================
; check for Up collision
; we check the middle char over the
; sprite
; C=1 if there is the up collision
;==================================            
checkUp:
      lda  yAct,x
      sbc  #21
      jmp  check     

;==================================
; Check the ground below the actor
; C=1 if there is the ground (collision)
;================================== 
checkGround:  
      lda yAct,x
check:      
      jsr  commonCheck 
      dey                         ; use the center character

      lda  (temp1),y              ; read the char under the actor
      cmp  #CHARLIMIT
      rts   
      
;==================================
; Check the ground below the actor
; but at dx of it
; C=1 if there is the ground (collision)
;================================== 
checkDxGround:  
      lda yAct,x   
      jsr  commonCheck      

      lda  (temp1),y              ; read the char under the actor
      cmp  #CHARLIMIT
      rts         
      
;=================================
; Common part of the check routine
; A= in: y actor position to check
; Y= out: char position in row to 
;         check
;=================================
commonCheck:
      lsr
      lsr
      lsr                         ; =/8 (row position)

      tay
      lda  rowTblLo,y
      sta  temp1
      lda  rowTblHi,y
      sta  temp2

      lda  xActHi,x               ; divide x position by 8 
      sta  temp3
      lda  xActLo,x
      lsr  temp3
      ror
      lsr  temp3
      ror
      lsr  temp3
      ror

      tay
      rts      
            
rowTblLo:
N      SET 0
       REPEAT 24
       dc.b #<($400+N*40)
N      SET N+1
       REPEND
rowTblHi:
N      SET 0
       REPEAT 24
       dc.b #>($400+N*40)
N      SET N+1
       REPEND     
       

;=================================
; check if there is a diamond 
; in one char near the actor
; and remove it from the memory map
;=================================       
ckeckDiamond:
      ldx  #00
      jsr  checkGround
      cmp  #CH_DIAM1              ; check diamond under actor
      beq  isDiamond
      
      jsr  checkUp
      cmp  #CH_DIAM1              ; check diamond over actor
      beq  isDiamond
      
      jsr  checkSx                ; check diamond at sx of actor                
      cmp  #CH_DIAM1
      beq  isDiamond
      
      jsr  checkDx                ; check diamond at dx of actor
      cmp  #CH_DIAM1
      bne  exitDiamond
      
isDiamond:
      lda  #CH_SPACE              ; filled the diamond with a space in current memory map
      sta  (temp1),y      
      sed                         ; decimal mode
      sec
      lda  bonus                  ; a bonus is taken 
      adc  #0
      sta  bonus
      cld
      
      cmp  #BLIFE                 ; test if we have enought bonus for having a new life
      bne  noExtraL
      
      lda  #0
      sta  bonus                  ; clear bonus

      jsr  incLife                ; add a new life       
      
noExtraL:      
      lda  #DIAMPOINT
      jsr  addScore               ; add point  
exitDiamond:      
      rts 
      
;=================================
; part of moveActor0      
;=================================
isJumping:                        ; actor is jumping 
      jsr  checkUp                ; chek if she is collided with a block in up direction
      bcc  skipIJ
      jmp  jumpUpFinish
      
skipIJ:      
      lda  xActSpeed              ; if speed x <>0 we must chack even at sx and dx 
      beq  skipTestSD            
      
      jsr  checkSx                ; check if she is collided with a block at sx
      bcs  jumpUpFinish
      
      jsr  checkDx                ; check if she is collided with a block at dx
      bcs  jumpUpFinish

skipTestSD:      
      inc  accDel
      lda  accDel
      cmp  #JUMPDEL               ; test for delay of acceleration
      bcc  madeMove
      
      inc  yActSpeed              ; increase speed (accceleration)
      beq  jumpUpFinish
acc0:      
      lda  #0
      sta  accDel                 ; reset acceleration delay 
      ;jmp  madeMove       
      
madeMove:                         ; made the x/y actor movement
      ldx  #00
      jsr  moveActor0X
      jsr  moveActorY
      rts                 
      
;=================================
; Move actor 0 according to user 
; joystick action
;=================================      
moveActor0:      
      ldx  #0
      lda  jump
      cmp  #1
      beq  isJumping
      bcs  isFalling      
      
      lda  joystick
      and  #JOY_UP                ; is going up?  
      bne  moveUp
      
contMov:      
      jsr  checkGround            ; check if we are always in conctat with ground
      bcc  activateFallDown       ; no, so we are falling

      lda  joystick
      and  #JOY_LEFT              ; is going left?
      bne  movLeft
      
      lda  joystick
      and  #JOY_RIGHT             ; is going right?
      bne  movRight
      
      lda  2040                   ; put base sprite even for sx or dx facing
      and  #$FE
      sta  2040 
      
      lda  #0
      sta  xActSpeed              ; set x speed to 0
      jmp  madeMove
              
isFalling:   
      jsr  checkSx                ; check if she is collided with a block at sx
      bcs  setX0
      
      jsr  checkDx                ; check if she is collided with a block at dx
      bcs  setX0 
      
accFalling:      
      jsr  checkGround            ; check for a collision with the ground 
      bcs  isAtFlow   
      
      jsr  checkDxGround          ; chek for a collision at dx with ground
      bcc  contAccFalling
      jmp  testSetFlow
      
contAccFalling:            
      inc  accDel
      lda  accDel
      cmp  #JUMPDEL               ; test for delay of acceleration
      bcc  madeMove  
      
      lda  yActSpeed
      cmp  #8                     ; limiy y movement to 8 bits for not going into the flow     
      beq  skipInc  
      inc  yActSpeed
skipInc:      
      jmp  madeMove
      
jumpUpFinish:
activateFallDown:
      lda  #2
      sta  jump                   ; activate fall sequence
      lda  #1
      sta  yActSpeed              ; set y speed to 1
      bne  acc0 
      
moveUp:
      lda  jumpDelay              ; don't jump until the delay is passed
      bne  contMov

      lda  #1
      sta  jump                   ; she is now jumping
      lda  #0
      sta  accDel                 ; reset acceleration delay
      lda  #JUMPSPEED
      sta  yActSpeed              ; give initial y up-speed
      jmp  madeMove        
      
movLeft:
      lda  2040                   ; put sx facing  
      ora  #$02
      sta  2040
      
      jsr  checkSx                ; chek for a sx collision
      bcs  stopMove      
      
      lda  #$FE                   ; -2=sx of 2 pixels
      sta  xActSpeed            
      jmp  madeMove
      
movRight:
      lda  2040                   ; put dx facing
      and  #$FD
      sta  2040
      
      jsr  checkDx                ; chek for a dx collision
      bcs  stopMove
      
      lda  #2                     ; go at dx with 2 pixels of movement 
      sta  xActSpeed         
      jmp  madeMove
              
setX0:                            ; set x velocity to 0 due to a collision                                     
      lda  xActSpeed  
      eor  #$FF
      sec
      adc  #00
      sta  xActSpeed      
      jsr  moveActor0X            ; we move the actor in the opposite direction to avoid 
                                  ; a background collision in middle of a block 
      lda  #0                     ; now the actor as collided and he fall down vertically
      sta  xActSpeed  
      inc  statFall               ; can't set flow if we have collide in jumping
      jmp  accFalling   
      
isAtFlow:                         ; we are at flow
      lda  #0
      sta  jump                   ; jump is finished
      sta  yActSpeed              ; y speed is finished
      sta  statFall               ; reset falling state for flow      
      
      lda  yAct                   ; fix alignement to up of char
      and  #$f8
      sta  yAct
      
      lda  #JUMPDELAY             ; set that there is a delay for the next jump
      sta  jumpDelay
      rts ;jmp  madeMove      
      
testSetFlow:     
      lda  statFall               ; don't test if statFall is set
      bne  jmpCAccFal 
 
      lda  xActSpeed
      bne  jmpCAccFal             ; if xspeed <>0 we cannot set the flow in falling here
            
      lda  #1
      sta  statFall               ; statFall is 1: cannot test again here
      
      lda  joystick
      and  #JOY_RIGHT             ; is going right?
      beq  jmpCAccFal             ; no, so don't set fall here
        
            
      lda  xActLo                 ; add 2/3 pixel to x direction for making true flow collision
      adc  #2
      sta  xActLo
      bcc  skipFixHi
      lda  xActHi
      adc  #0
      sta  xActHi
      
skipFixHi:
      jmp  isAtFlow
      
jmpCAccFal:
      jmp  contAccFalling               
      
stopMove:                         ; stop the x movement of actor
      lda  #00
      sta  xActSpeed
      jmp  madeMove      

;=================================
; Move actor 0 to x direction only
; if it stays into the visible
; screen region
;=================================      
moveActor0X:
      ldx  #0
      lda  xActSpeed              ; test at sx or dx according to the direction
      bmi  dirLeft
      lda  xActHi  
      beq  madeMove0
      lda  xActLo
      cmp  #(306-256)             ; test right
      bcc  madeMove0
      
      lda  #2                     ; we pass the screen
      sta  status
      jmp  exitA0X
madeMove0:
      jsr  moveActorX
      rts
dirLeft:   
      lda  xActHi
      bne  madeMove0
      lda  xActLo
      cmp  #15                    ; test left
      bcs  madeMove0
exitA0X    
      rts         
            
;==================================
; Move an actor to x direction 
; according with his speed (>0=DX)
;==================================
moveActorX:     
      clc
      lda  xActSpeed,x            ; read speed in x direction
      bmi  negMoveX
                
      lda  xActHi,x              ; if the actor is at right, give left speed
      beq  posMoveX                     
      
      lda  xActLo,x
      cmp  #(306-256)
      bcc  posMoveX
      
      lda  #$FE                   ; -2=sx of 2 pixels
      sta  xActSpeed,x
      bne  negMoveX  
      
posMoveX:      
      lda  xActSpeed,x            ; read speed in x direction
      adc  xActLo,x               ; move to dx
      sta  xActLo,x
      lda  xActHi,x
      adc  #$00
      sta  xActHi,x
      rts
negMoveX:                         ; move to sx  
      adc  xActLo,x
      sta  xActLo,x
      lda  xActHi,x
      adc  #$ff
      sta  xActHi,x
exitMovX:      
      rts
      
;==================================
; Move actor 0 to y direction 
; according with his speed
;==================================    
moveActor0Y:
      lda  yActSpeed
      clc
      adc  yAct
      sta  yAct
      rts           
      
;==================================
; Move an actor to y direction 
; according with his speed
;==================================    
moveActorY:
      lda  yActSpeed,x
      clc
      adc  yAct,x
      sta  yAct,x
      rts     
            
;==================================
; Get Joystick movement
;==================================      
getJoystick:
      lda  #$FF
      sta  $DC00
      lda  $DC00
      eor  #$FF
      sta  joystick
      rts
 
;==================================
; Wait for IRQ before going on
;==================================         
waitIRQ:
      lda  GO
      beq  waitIRQ
      dec  GO    
      rts
 
                 

;=================================
; Check for scroll:
; A= amount to scroll
;=================================    
checkScroll:
      ldx  #$00
      lda  xActHi
      cmp  #1
      bcs  needScroll
      lda  xActLo
      cmp  #200
      bcc  noneedScroll
needScroll:     
      ldx  #$02
noneedScroll: 
      txa
      rts  

;=================================
; Made the hw/sw Scroll 
; A = pixel to shift (0..4)
;=================================    
madeScroll:
      ldx  xMap                   ; test if we reach the end of the map 
      cpx  #MAPSIZE
      bcc  canMadeScroll
      rts
      
canMadeScroll:                    ; store tha amount of shift for sprite and graphics
      sta  shiftVel+1
      sta  shiftSVel+1 
      
      ldx  #7                     ; shift all the sprite according to the graphics 
doScrollSpr:    
      lda  xActLo,x
      sec
shiftSVel:
      sbc  #$00
      sta  xActLo,x
      lda  xActHi,x
      sbc  #$00
      sta  xActHi,x
      dex
      bpl  doScrollSpr
                      
      lda  xScroll                ; shift the graphics 
      sec
shiftVel:
      sbc  #$00
      bmi  swShift
      sta  xScroll
      rts
swShift: 
      and  #$07
      sta  xScroll
      ;rts 
   
;=================================
; Shift the memory graphics to sx
;=================================  
shiftGraphics:
      ldx  #$00                   ; shift the memory map to sx of one char
loopSG:
N     SET  4                      ; from line 4 until 24
      REPEAT 20
      lda  $0400+N*40+1,x
      sta  $0400+N*40,x
N     SET  N+1
      REPEND
      inx
      cpx  #39
      bne  loopSG
      
      lda  #4                     ; shift the color map to sx of one char every 4 columns
      clc                         ; as one block use the same color map
      sbc  xBlock
      and  #3
      tax
      clc
      adc  #1
      tay      
loop2SG:
M     SET  4
      REPEAT 20
      lda  $D800+M*40,y
      sta  $D800+M*40,x
M     SET  M+1
      REPEND
      txa
      clc
      adc  #4
      tax
      tay
      iny
      cpy  #40
      bcs  exitSG
      jmp  loop2SG
exitSG:      
      ;rts            

;=================================
; Draw next char in block of last 
; column
;=================================
      lda  mapAddr                ; set the actual map pointer 
      clc
      adc  xMap
      sta  actMapAddr 
      lda  mapAddr+1
      adc  #$00
      sta  actMapAddr+1

      lda  #<($400+4*40+39)       ; set destination (last char of first line)
      sta  dest
      lda  #>($400+4*40+39)
      sta  dest+1

      lda  #<($D800+4*40+39)       ; set destination (last char of first line)
      sta  cDest
      lda  #>($D800+4*40+39)
      sta  cDest+1          

      lda  #20                    ; we have 20 rows to update
      sta  rowLeft 

      ldy  #$00
      sty  temp1                  ; row position index

loopWrite:
      ldx  xBlock

      lda (actMapAddr),y          ; read next block in the map for this row 
      tay
      
      lda  BKCOLOR,y              ; read the color for this block
      sta  actBkColor             ; remember actual color for this block

      lda  blockTblLo,y           ; read source pos from table
      sta  sourcePos+1
      lda  blockTblHi,y
      sta  sourcePos+2

      lda  actMapAddr             ; next row of the map is MAPSIZE after          
      clc
      adc  #MAPSIZE
      sta  actMapAddr             ; adjust map pointer low
      lda  actMapAddr+1
      adc  #$00
      sta  actMapAddr+1           ; adjust map pointer hi   
      ldy  #$00

sourcePos:
      lda  $1000,x                ; read the right caracter
      sta  (dest),y               ; write to the destination
      
      cmp  #CH_MONST
      bne  skipMons
      
      lda  temp1
      sta  enemy                  ; set enemy row position  
skipMons:            
      inc  temp1                  ; set for next row 

      lda  actBkColor
      sta  (cDest),y              ; write color to destination

      lda  dest                   ; move destination to the next row
      clc
      adc  #40
      sta  dest
      lda  dest+1
      adc  #0
      sta  dest+1
      
      lda  cDest                  ; move color destination to the next row
      clc
      adc  #40
      sta  cDest
      lda  cDest+1
      adc  #0
      sta  cDest+1      

      txa
      adc  #4
      tax

      dec rowLeft                 ; one row is out
      beq nextInBlock

      cpx #$10
      bcc sourcePos
      jmp loopWrite
       
nextInBlock:                      ; set pointer for next block & increase map if necessary        
      inc  xBlock
      lda  xBlock
      cmp  #$04
      bcc  exitIB
      lda  #$00
      sta  xBlock
      inc  xMap
exitIB:      
      rts      
      
    
   
  .org $2000
SP_RIGHT1:
  .byte 0, 69, 16, 4, 85, 64, 1, 85, 64
  .byte 17, 69, 16, 5, 91, 0, 69, 107, 128
  .byte 21, 170, 128, 21, 170, 0, 85, 170, 0
  .byte 22, 168, 0, 23, 240, 0, 87, 172, 0
  .byte 23, 168, 0, 7, 234, 0, 23, 250, 0
  .byte 7, 252, 0, 0, 252, 0, 0, 240, 0
  .byte 0, 240, 0, 1, 84, 0, 1, 84, 0, 0
  
SP_RIGHT2:
  .byte 1, 4, 64, 0, 85, 80, 5, 85, 64
  .byte 1, 90, 16, 21, 91, 0, 5, 107, 128
  .byte 85, 170, 128, 21, 170, 0, 85, 170, 0
  .byte 22, 168, 0, 23, 240, 0, 87, 172, 0
  .byte 23, 170, 0, 7, 234, 0, 7, 252, 0
  .byte 23, 252, 0, 0, 252, 0, 1, 241, 0
  .byte 1, 117, 0, 0, 69, 0, 0, 84, 0, 0      
  
SP_LEFT1:
  .byte 4, 81, 0, 1, 85, 16, 1, 85, 64
  .byte 4, 81, 68, 0, 229, 80, 2, 233, 81 
  .byte 2, 170, 84, 0, 170, 84, 0, 170, 85
  .byte 0, 42, 148, 0, 15, 213, 0, 58, 213
  .byte 0, 42, 212, 0, 171, 208, 0, 175, 212
  .byte 0, 63, 208, 0, 63, 0, 0, 15, 0
  .byte 0, 15, 0, 0, 21, 64, 0, 21, 64, 0
  
SP_LEFT2:
  .byte 1, 16, 64, 5, 85, 0, 1, 85, 80
  .byte 4, 165, 64, 0, 229, 84, 2, 233, 80
  .byte 2, 170, 85, 0, 170, 84, 0, 170, 85
  .byte 0, 42, 148, 0, 15, 212, 0, 58, 213
  .byte 0, 170, 212, 0, 171, 208, 0, 63, 208
  .byte 0, 63, 212, 0, 63, 0, 0, 79, 64
  .byte 0, 93, 64, 0, 81, 0, 0, 21, 0, 0
  
SP_MONSTER:
  ;.byte 128, 195, 2, 160, 40, 10, 40, 40, 40
  ;.byte 10, 170, 160, 2, 170, 128, 3, 125, 192
  ;.byte 3, 105, 192, 3, 235, 192, 10, 170, 160
  ;.byte 41, 105, 104, 37, 105, 88, 170, 170, 170
  ;.byte 169, 105, 106, 165, 85, 90, 165, 85, 90
  ;.byte 165, 85, 90, 129, 85, 66, 129, 85, 66
  ;.byte 138, 85, 162, 10, 130, 160, 2, 130, 128, 0    
  
  ;.byte $80, $41, $02, $60, $18, $0a, $14, $5a, $28
  ;.byte $45, $6a, $a1, $11, $69, $84, $05, $d7, $50
  ;.byte $15, $db, $54, $01, $59, $40, $06, $9a, $a0
  ;,.byte $1b, $db, $e8, $1f, $db, $f8, $1a, $9a, $a8
  ;.byte $6b, $d7, $da, $6f, $ff, $f6, $6f, $ff, $f6
  ;.byte $6f, $ff, $f6, $43, $be, $c2, $43, $eb, $c2
  ;.byte $4a, $d7, $a2, $05, $41, $a0, $01, $41, $40, $00
  
  .byte $80, $c3, $02, $e0, $38, $0a, $3c, $fa, $28
  .byte $cf, $ea, $a3, $33, $eb, $8c, $0f, $7d, $f0
  .byte $3f, $79, $fc, $03, $fb, $c0, $0e, $ba, $a0
  .byte $39, $79, $68, $35, $79, $58, $3a, $ba, $a8
  .byte $e9, $7d, $7a, $e5, $55, $5e, $e5, $55, $5e
  .byte $e5, $55, $5e, $c1, $96, $42, $c1, $69, $42
  .byte $ca, $7d, $a2, $0f, $c3, $a0, $03, $c3, $c0, $00 

  
xScroll:                          ; x scroll value       
  .byte $03     
  
xMap:                             ; x position within the map 
  .byte $00  
  
xBlock:                           ; x position within a block (0..3)
  .byte $00  
  
rowLeft:
  .byte $00                       ; row left to copy
  
xActLo:                           ; lo x position of sprites (actors) 
  .byte $00, $00, $00, $00, $00, $00, $00, $00
  
xActHi:                           ; hi x position of sprites (actors)
  .byte $00, $00, $00, $00, $00, $00, $00, $00    
  
yAct:                             ; y position of sprites (actors)
  .byte $00, $00, $00, $00, $00, $00, $00, $00     

actType:                          ; actor type (0=not to show) 
  .byte $00, $00, $00, $00, $00, $00, $00, $00  

xActSpeed:                        ; speed of the actor (>0=DX)
  .byte $00, $00, $00, $00, $00, $00, $00, $00        
  
yActSpeed:                        ; speed of the actor in y direction
  .byte $00; , $00, $00, $00, $00, $00, $00, $00   we not use y speed for monster
  
time:                             ; time counter
  .byte $00
  
timeDl:                           ; time delay counter
  .byte $00   
  
bonus:                            ; number of bonus (diamons) taken
  .byte $00  
  
lifes:                            ; number of lifes (9 max)
  .byte $00  
  
level:                            ; the level we are (0=level 1)
  .byte $00  
  
enemy:                            ; <>0 = char row where to add an enemy
  .byte $00  
  
score:                            ; actual score
  .byte $00, $00, $00  
  
hiScore:                          ; high score
  .byte $00, $00, $00                     
  
; custom char definition (made with bgedit3)
 .org $2400
char:
CH_SPACE = 32; null char: use the C= one to save some bytes
  ;.byte $00, $00, $00, $00, $00, $00, $00, $00
  
CH_MONST = 64 ; null char for monster
  .byte $00, $00, $00, $00, $00, $00, $00, $00

CH_CLOUD = CH_MONST+1
  ;.byte $00, $37, $7f, $3f, $3f, $7a, $77, $7a 
  ;.byte $00, $00, $f8, $ff, $ff, $ff, $5d, $fe
  ;.byte $00, $0f, $1f, $ff, $f5, $ff, $f5, $f5
  ;.byte $30, $f8, $fc, $fc, $be, $df, $3f, $ff
  ;.byte $3e, $7b, $fd, $ff, $3f, $1f, $1f, $07
  ;.byte $fe, $db, $ff, $ff, $cc, $ff, $ef, $00
  ;.byte $bb, $ab, $ff, $9b, $ff, $ff, $7f, $3c
  ;.byte $bf, $bf, $7e, $78, $f0, $f0, $e0, $80 
  .byte $00, $07, $1d, $2f, $5f, $5f, $7f, $41   ; from Luca
  .byte $7f, $ff, $ff, $ff, $ff, $ff, $c0, $3f   ; from Luca 
  .byte $fc, $ff, $ff, $ff, $ff, $ff, $ff, $3f   ; from Luca
  .byte $00, $80, $e0, $f8, $fc, $fe, $fe, $ff   ; from Luca 
  .byte $3e, $4d, $bf, $ff, $ff, $ff, $7f, $1f   ; from Luca
  .byte $ff, $ff, $ff, $ff, $bf, $bf, $df, $e0   ; from Luca 
  .byte $d7, $eb, $f5, $f2, $b5, $6a, $95, $00   ; from Luca
  .byte $fd, $fd, $fd, $fa, $fc, $f0, $80, $00   ; from Luca 
                                                                     
  
CH_DIAM1 = 73 
CHS_DIAM1 = 105
  ;.byte $18, $3c, $76, $eb, $d7, $6e, $3c, $18
  .byte $18, $34, $4a, $bb, $dd, $52, $2c, $18   ; from Luca
    
CHARLIMIT = 74    ; below this we can walk; over we collide
  
CH_GR1 = 74
  .byte $5f, $fa, $e9, $e9, $e5, $e5, $e5, $e5  
  .byte $ad, $a9, $6d, $5e, $5e, $5e, $7a, $7a
  
CH_GR2 = CH_GR1+2  
  .byte $95, $aa, $bb, $aa, $ae, $bb, $ae, $ff
  .byte $5b, $ab, $a3, $8b, $a3, $8b, $a3, $cf  
  
CH_KILL1 = CH_GR2+2
  .byte $40, $44, $44, $44, $44, $44, $44, $44
  .byte $4e, $ee, $ee, $ee, $e4, $ea, $e0, $ff
  
CH_WALL1 = CH_KILL1+2
  ;.byte $55, $6a, $6a, $ff, $55, $a9, $a9, $ff
  ;.byte $55, $a9, $a9, $ff, $55, $6a, $6a, $ff 
  .byte $57, $AB, $75, $BA, $56, $AB, $AB, $65   ; from Luca
  .byte $BA, $BA, $BA, $56, $57, $AB, $AB, $AB   ; from Luca  
  ;.byte $57, $EB, $75, $BE, $56, $EB, $AB, $65   ; from Luca (shadoed)
  ;.byte $BE, $BA, $BA, $56, $57, $FB, $A7, $A7   ; from Luca (shadoed) 
  
 
  
; blocks definitions in this form:
; ABCD
; EFGH  =>  ABCD EFGH IJKL MNOP
; IJKL  
; MNOP

BLOCKS:
BK_SPACE = 0
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE  
  
BK_SPMON = 1          ; space and monster
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_MONST,   CH_SPACE,   CH_SPACE,   CH_SPACE  

BK_CLOUD_UP = 2
  .byte CH_CLOUD+0, CH_CLOUD+1, CH_CLOUD+2, CH_CLOUD+3     
  .byte CH_CLOUD+4, CH_CLOUD+5, CH_CLOUD+6, CH_CLOUD+7
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  
BK_CLOUD_MD = BK_CLOUD_UP +1
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_CLOUD+0, CH_CLOUD+1, CH_CLOUD+2, CH_CLOUD+3
  .byte CH_CLOUD+4, CH_CLOUD+5, CH_CLOUD+6, CH_CLOUD+7  
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  
BK_CLOUD_DN = BK_CLOUD_MD +1
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_CLOUD+0, CH_CLOUD+1, CH_CLOUD+2, CH_CLOUD+3
  .byte CH_CLOUD+4, CH_CLOUD+5, CH_CLOUD+6, CH_CLOUD+7  
  
BK_GR1 =  BK_CLOUD_DN +1
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_GR1+0,   CH_GR1+1,   CH_GR1+0,   CH_GR1+1
  .byte CH_GR1+1,   CH_GR1+0,   CH_GR1+1,   CH_GR1+0
  .byte CH_GR1+0,   CH_GR1+1,   CH_GR1+0,   CH_GR1+1  
  
BK_GR2 =  BK_GR1 +1
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_GR2+0,   CH_GR2+1,   CH_GR2+0,   CH_GR2+1
  .byte CH_GR2+1,   CH_GR2+0,   CH_GR2+1,   CH_GR2+0
  .byte CH_GR2+0,   CH_GR2+1,   CH_GR2+0,   CH_GR2+1   
  
BK_GRMON =  BK_GR2 +1
  .byte CH_SPACE,   CH_MONST,   CH_SPACE,   CH_SPACE
  .byte CH_GR1+0,   CH_GR1+1,   CH_GR1+0,   CH_GR1+1
  .byte CH_GR1+1,   CH_GR1+0,   CH_GR1+1,   CH_GR1+0
  .byte CH_GR1+0,   CH_GR1+1,   CH_GR1+0,   CH_GR1+1   

BK_GRMO2 =  BK_GRMON +1
  .byte CH_SPACE,   CH_MONST,   CH_SPACE,   CH_SPACE
  .byte CH_GR2+0,   CH_GR2+1,   CH_GR2+0,   CH_GR2+1
  .byte CH_GR2+1,   CH_GR2+0,   CH_GR2+1,   CH_GR2+0
  .byte CH_GR2+0,   CH_GR2+1,   CH_GR2+0,   CH_GR2+1    
  
BK_KILL1 =   BK_GRMO2 +1
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_KILL1+0, CH_KILL1+0, CH_KILL1+0, CH_KILL1+0
  .byte CH_KILL1+1, CH_KILL1+1, CH_KILL1+1, CH_KILL1+1
  
BK_WALL1 =  BK_KILL1 +1
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_WALL1+0, CH_WALL1+1
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_WALL1+0, CH_WALL1+1
  .byte CH_WALL1+0, CH_WALL1+0, CH_WALL1+0, CH_WALL1+0   ; from Luca
  .byte CH_WALL1+1, CH_WALL1+1, CH_WALL1+1, CH_WALL1+1   ; from Luca  
  
BK_WALL2 =  BK_WALL1 +1
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_WALL1+0, CH_WALL1+1
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_WALL1+0, CH_WALL1+1  
  .byte CH_WALL1+0, CH_WALL1+0, CH_WALL1+0, CH_WALL1+0   ; from Luca
  .byte CH_WALL1+1, CH_WALL1+1, CH_WALL1+1, CH_WALL1+1   ; from Luca       
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  
BK_WALL3 =  BK_WALL2 +1
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_WALL1+0, CH_WALL1+1
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_WALL1+0, CH_WALL1+1  
  .byte CH_WALL1+0, CH_WALL1+0, CH_WALL1+0, CH_WALL1+0   ; from Luca
  .byte CH_WALL1+1, CH_WALL1+1, CH_WALL1+1, CH_WALL1+1   ; from Luca      
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  
BK_DM_UP = BK_WALL3 +1
  .byte CH_SPACE,   CH_SPACE,   CH_DIAM1,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  .byte CH_SPACE,   CH_SPACE,   CH_SPACE,   CH_SPACE
  
BK_COL1 =  BK_DM_UP +1
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_SPACE,   CH_SPACE
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_SPACE,   CH_SPACE
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_SPACE,   CH_SPACE
  ;.byte CH_WALL1+0, CH_WALL1+1, CH_SPACE,   CH_SPACE  
  .byte CH_WALL1+0, CH_WALL1+0, CH_SPACE,   CH_SPACE   ; from Luca    
  .byte CH_WALL1+1, CH_WALL1+1, CH_SPACE,   CH_SPACE   ; from Luca    
  .byte CH_WALL1+0, CH_WALL1+0, CH_SPACE,   CH_SPACE   ; from Luca    
  .byte CH_WALL1+1, CH_WALL1+1, CH_SPACE,   CH_SPACE   ; from Luca      
          
blockTblLo:
N SET 0
  REPEAT 15
  .byte #<(BLOCKS+N*16)
N SET N+1
  REPEND

blockTblHi:
N SET 0
  REPEAT 15
  .byte #>(BLOCKS+N*16)
N SET N+1
  REPEND
  

MAP0:
  ;        0         1          2            3            4          5         6            7          8          9             10         11        12        13           14         15         16         17           18         19        20                  ;        21           22         23         24         25        26        27        28           29        30        31           32        33        34        35        36        37         38        39                                             
  .byte BK_SPACE, BK_SPACE,  BK_CLOUD_MD, BK_SPACE,   BK_SPACE,  BK_SPACE, BK_CLOUD_UP, BK_SPACE,  BK_SPACE,  BK_SPACE,  BK_CLOUD_DN, BK_SPACE,  BK_SPACE,  BK_CLOUD_MD,  BK_SPACE,  BK_SPACE, BK_SPACE, BK_CLOUD_DN, BK_SPACE,  BK_SPACE,  BK_SPACE               .byte BK_CLOUD_MD, BK_SPACE,  BK_SPACE,  BK_SPACE,  BK_SPACE, BK_SPACE, BK_SPACE, BK_CLOUD_MD, BK_SPACE, BK_SPACE, BK_CLOUD_DN, BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE, BK_CLOUD_UP, BK_SPACE            
  .byte BK_SPACE, BK_SPACE,  BK_SPACE,    BK_SPACE,   BK_SPACE,  BK_SPACE, BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_DM_UP,  BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_SPACE,     BK_SPACE,  BK_SPACE, BK_SPACE, BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_SPACE               .byte BK_SPACE,    BK_DM_UP,  BK_SPACE,  BK_SPACE,  BK_DM_UP, BK_WALL3, BK_SPACE, BK_SPACE,    BK_SPACE, BK_SPACE, BK_SPACE,    BK_WALL1, BK_SPACE, BK_WALL3, BK_COL1,  BK_SPACE, BK_SPMON,    BK_SPACE
  .byte BK_SPACE, BK_SPACE,  BK_SPACE,    BK_SPACE,   BK_DM_UP,  BK_SPACE, BK_SPACE,    BK_DM_UP,  BK_SPACE,  BK_WALL1,  BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_SPACE,     BK_SPACE,  BK_SPACE, BK_SPACE, BK_SPACE,    BK_DM_UP,  BK_SPMON,  BK_SPACE               .byte BK_SPACE,    BK_WALL1,  BK_SPACE,  BK_WALL2,  BK_WALL2, BK_SPACE, BK_SPACE, BK_WALL3,    BK_DM_UP, BK_SPACE, BK_SPACE,    BK_SPACE, BK_SPACE, BK_WALL1, BK_COL1,  BK_WALL3, BK_WALL3,    BK_SPACE
  .byte BK_SPACE, BK_SPACE,  BK_SPACE,    BK_SPACE,   BK_DM_UP,  BK_SPACE, BK_SPACE,    BK_WALL3,  BK_WALL3,  BK_SPACE,  BK_DM_UP,    BK_SPACE,  BK_SPACE,  BK_SPACE,     BK_SPACE,  BK_DM_UP, BK_SPACE, BK_SPACE,    BK_WALL3,  BK_WALL3,  BK_SPACE               .byte BK_WALL3,    BK_SPACE,  BK_SPACE,  BK_SPACE,  BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE,    BK_SPACE, BK_DM_UP, BK_SPACE,    BK_SPACE, BK_WALL3, BK_SPACE, BK_COL1,  BK_SPACE, BK_SPACE,    BK_SPACE
  .byte BK_GR1,   BK_GR1,    BK_GR1,      BK_GR1,     BK_GR1,    BK_GR1,   BK_GR1,      BK_GR1,    BK_GR1,    BK_GR1,    BK_GRMON,    BK_GRMON,  BK_KILL1,  BK_GR1,       BK_GR1,    BK_GR1,   BK_GR1,   BK_GRMON,    BK_GR1,    BK_GR1,    BK_KILL1               .byte BK_KILL1,    BK_KILL1,  BK_KILL1,  BK_KILL1,  BK_KILL1, BK_KILL1, BK_KILL1, BK_KILL1,    BK_GR1,   BK_GR1,   BK_GR1,      BK_GR1,   BK_GRMON, BK_KILL1, BK_KILL1, BK_KILL1, BK_GR1,      BK_GR1
  
MAP1:  
  ;        0         1          2            3           4          5         6            7          8          9             10         11        12        13           14         15         16         17           18         19        20                   ;        21           22         23         24         25        26        27        28           29        30        31           32        33        34        35        36        37         38        39                                             
  .byte BK_GR2,   BK_GR2,    BK_GR2,      BK_GR2,     BK_GR2,    BK_GR2,   BK_GR2,      BK_GR2,    BK_GR2,    BK_GR2,    BK_GR2,      BK_GR2,    BK_GR2,    BK_GR2,       BK_GR2,    BK_GR2,   BK_GR2,   BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_SPACE               .byte BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_SPACE,  BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE,    BK_SPACE, BK_SPACE, BK_SPACE,    BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE,   BK_SPACE             
  .byte BK_COL1,  BK_SPACE,  BK_SPACE,    BK_SPACE,   BK_SPACE,  BK_SPACE, BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_SPACE,  BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_SPACE,     BK_SPACE,  BK_SPACE, BK_SPACE, BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_SPACE               .byte BK_SPACE,    BK_DM_UP,  BK_SPACE,  BK_SPACE,  BK_DM_UP, BK_WALL3, BK_SPACE, BK_SPACE,    BK_DM_UP, BK_SPMON, BK_SPACE,    BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE,   BK_SPACE
  .byte BK_COL1,  BK_SPACE,  BK_SPACE,    BK_SPACE,   BK_SPACE,  BK_SPACE, BK_SPACE,    BK_DM_UP,  BK_SPACE,  BK_SPACE,  BK_SPACE,    BK_SPACE,  BK_SPACE,  BK_SPACE,     BK_SPACE,  BK_SPACE, BK_SPACE, BK_SPACE,    BK_DM_UP,  BK_SPMON,  BK_SPACE               .byte BK_DM_UP,    BK_WALL1,  BK_WALL1,  BK_SPACE,  BK_WALL2, BK_SPACE, BK_SPACE, BK_WALL3,    BK_WALL3, BK_WALL3, BK_SPACE,    BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE,   BK_SPACE  
  .byte BK_SPACE, BK_SPACE,  BK_DM_UP,    BK_DM_UP,   BK_DM_UP,  BK_DM_UP, BK_SPACE,    BK_DM_UP,  BK_SPACE,  BK_SPACE,  BK_DM_UP,    BK_SPACE,  BK_SPACE,  BK_SPACE,     BK_SPACE,  BK_DM_UP, BK_SPACE, BK_SPACE,    BK_WALL3,  BK_WALL3,  BK_WALL3               .byte BK_WALL3,    BK_SPACE,  BK_SPACE,  BK_SPACE,  BK_SPACE, BK_SPACE, BK_SPACE, BK_SPACE,    BK_SPACE, BK_DM_UP, BK_SPACE,    BK_DM_UP, BK_SPACE, BK_SPACE, BK_DM_UP, BK_SPACE, BK_SPACE,   BK_SPACE
  .byte BK_WALL2, BK_WALL2,  BK_WALL2,    BK_WALL2,   BK_WALL2,  BK_WALL2, BK_GR2,      BK_GR2,    BK_GR2,    BK_GR2,    BK_GRMO2,    BK_GRMO2,  BK_GRMO2,  BK_GR2,       BK_GR2,    BK_GR2,   BK_GR2,   BK_GRMO2,    BK_GR2,    BK_GR2,    BK_KILL1               .byte BK_KILL1,    BK_KILL1,  BK_KILL1,  BK_KILL1,  BK_KILL1, BK_KILL1, BK_KILL1, BK_KILL1,    BK_GR2,   BK_GR2,   BK_GR2,      BK_GR2,   BK_GRMO2, BK_KILL1, BK_GR2,   BK_GRMO2, BK_GR2,     BK_GR2 
    
  
; color information for block
BKCOLOR:
  .byte $01, $01, $01, $01, $01     ; white  -> BK_CLOUD blocks
  .byte $08, $08, $08, $08, $00, $08
  .byte $08, $08, $01, $08
;=================================
; Write win string
;=================================            
writeWin:
      ldx  #11                    
      ldy  #3
      jsr  SET_COOR
      lda  #<Swin
      ldy  #>Swin
      jsr  STRING                 ; put the name of the game 
      rts            
Swin:
  .byte 5,"WELL DONE SARA: YOU ARE THE BEST",0    
     
;=================================
; Write title of game
;=================================     
writeGameTitle:                                  
      ldx  #24                    
      ldy  #2
      jsr  SET_COOR
      lda  #<Sname
      ldy  #>Sname
      jsr  STRING                 ; put the name of the game 
      rts
Sname:
  .byte 5,"LITTLE SARA SISTER  BY ICE TEAM 2004",0   
;=================================
; give bonus: time*25 points
;=================================            
giveBonus:
      pha
      ldx  #13                    
      ldy  #10
      jsr  SET_COOR
      lda  #<Sbonus
      ldy  #>Sbonus
      jsr  STRING                 ; put the name of the game 
      pla
      
      tax
loopBonus:
      stx  temp3     
      lda  #$20
      jsr  addScore               ; add the score
      jsr  testScore              ; test if this is the high score
      jsr  writeScore
      jsr  waitIRQ
      ldx  temp3
      dex
      bne  loopBonus
      
      rts      
      
Sbonus:
  .byte 5,"BONUS:  TIME*20",0 
  
  
;=================================
; Write fire string
;=================================            
writeFire:
      ldx  #13                    
      ldy  #15
      jsr  SET_COOR
      lda  #<Sfire
      ldy  #>Sfire
      jsr  STRING                 ; put the name of the game 
      rts      
      
Sfire:
  .byte 5,"PRESS FIRE",0   
  
;=================================
; Write game over string
;=================================            
writeGameOver:
      ldx  #11                    
      ldy  #15
      jsr  SET_COOR
      lda  #<Sover
      ldy  #>Sover
      jsr  STRING                 ; put the name of the game 
      rts      
      
Sover:
  .byte 5,"GAME OVER",0  
  
        
  
;=================================
; Write the title of score
;=================================  
writeScoreTitle:
      ldx  #0                    
      ldy  #2
      jsr  SET_COOR
      lda  #<Sscore
      ldy  #>Sscore
      jsr  STRING                 ; put the name of the game 
      rts
Sscore:
  .byte 5,"POINTS   BONUS    LIVES  LEVEL  TIME             ",CHS_DIAM1,0  
  
;=================================
; Write the score
;=================================
writeScore:
      lda  bonus                  ; write the number of bonus     
      jsr  atoax
      stx  $400+40+14      
      sta  $400+40+15
      
      lda  lifes
      ora  #$30
      sta  $400+40+22
      
      lda  level
      clc
      adc  #49                    ; add '1'
      sta  $400+40+29        
      
      lda  time                   ; write the time
      jsr  atoax
      stx  $400+40+35    
      sta  $400+40+36
      
      ldx  #0
      jsr  writePoints
      ldx  #3
      jsr  writePoints
            
      rts    
  
;=================================      
; write score
; x=0/3 0 for score, 3 for highscore
;=================================
writePoints:
      ldy  #0
     
      lda  #$2A                   ; this is the low address for score ($42A)
      cpx  #3
      bne  skipws
     
      lda  #$52                   ; this is the high address for hiscore ($452) 
skipws:
      sta  wra1+1                 ; change low address as needed
      sta  wra2+1   
     
loopws:     
      lda  score,x
      pha
      lsr
      lsr
      lsr
      lsr
      ora  #$30
wra1:     
      sta  $400+40+2,y
      iny
      pla
      and  #$0F
      ora  #$30
wra2:     
      sta  $400+40+3,y
      inx
      iny
      cpy  #6
      bne  loopws
      rts      

;=================================            
; add points to score
; A=point to add     
;=================================
addScore:
      stx  temp3 
      ldx  #2
      ;ldy  #0                     ; clear carry indicator
      sed                         ; decimal mode
      clc
      adc  score,x
      sta  score,x
      bcc  exitscore
     
      ;iny                         ; carry indicator
      dex
      lda  #0
      adc  score,x
      sta  score,x
      bcc  exitscore
     
      dex
      lda  #0
      adc  score,x
      sta  score,x     
exitscore:     
      cld                         ; normal mode
     
      ;cpy  #0                     ; test carry indicator
      ;beq  skipAS
     
      ;lda  score+1                ; read middle of score
      ;and  #$3F
      ;cmp  #$40
      ;bne  skipAS                 ; if $40, we have reach another 4000 points
     
      ;jsr  incLife                ; give another life
skipAS:  
      ldx  temp3
      rts   
  
;=================================
; Inc life but not too much
;=================================
incLife:
      lda  lifes
      cmp  #9
      beq  skipLF                 ; we cannot have more then 9 lifes
     
      inc  lifes                  ; get an extra life
skipLF      
      rts        
      
      
;=================================
; Test if this score must be the 
; hiscore
;=================================      
testScore:
                                  ; test if we have a new highscore
      lda  score
      cmp  score+3                                  
      bmi  notHS
      bne  setHS
      
      lda  score+1
      cmp  score+4
      bmi  notHS
      bne  setHS
      
      lda  score+2
      cmp  score+5
      bmi  notHS
      bne  setHS
                                  
notHS:
      rts    
      
setHS:                             ; copy the score to hiscore 
      ldx  #3
setHS_:      
      lda  score-1,x
      sta  score+2,x
      dex
      bne  setHS_  
      beq  notHS     
  
;=================================
; Draw sprites according with their
; positions 
;=================================      
drawSprites: 
      lda  #$00
      sta  virtualX               ; virtual register for msx position of sprites  
      sta  virtualD               ; virtual register for display of sprites  
                
      ldx  #7

drawNext:
      lda  actType,x
      bne  toShow                 ; show if it is <>0
      jmp  skipFixH
     
toShow:         
      lda  virtualD
      ora  bitTable,x
      sta  virtualD               ; this sprite is to show

      lda  xActLo,x               ; fix x position for sprite center    
      clc
      adc  #12                    ; 24-12
      sta  temp1
      
      lda  xActHi,x
      adc  #$00
      sta  temp2

      lda  yAct,x                 ; fix y position for sprite center
      clc
      adc  #30                    ; 50-20      
      sta  temp3

      ; choose the right animation for sprite 0

      cpx  #00
      bne  skipFr0
      
      lda  xActSpeed,x
      beq  skipFr0
      
      lda  2040                   ; inc low bit as we have only 2 frames
      eor  #$01
      sta  2040
     
skipFr0:      
      txa
      asl                         ; *2
      tay

      lda  temp1
      sta  $d000,y                ; store x sprite position
      lda  temp3
      sta  $d001,y                ; store y sprite position

      lda  temp2
      beq  skipFixH
      
      lda  virtualX
      ora  bitTable,x
      sta  virtualX               ; store msb of position in virtual register

skipFixH:
      dex
      bmi  finalDraw
      jmp  drawNext 

finalDraw: 
      lda  virtualX               ; fix msx position of sprite
      sta  $d010
      lda  virtualD               ; show sprites
      sta  $d015
                
      rts

bitTable:
  .byte  1,2,4,8,16,32,64,128

    
;=================================
; Dec time of 1 sec. after 50
; frames 
;=================================  
decTime:      
      lda  time
      beq  noDecTime
      inc  timeDl
      lda  timeDl
      cmp  #50                    ; 50 frames (pal)=1 second
      bcc  noDecTime
      lda  #$00
      sta  timeDl                 ; reset time frame (delay) conter
      sed
      lda  time
      sec
      sbc  #$01                   ; sub 1 second (in decimal mode)
      sta  time
      cld
      bne  noDecTime

      ; time out 
      lda  #1                     ; we must died as out of time 
      sta  status
noDecTime: 
      rts
      
;=================================
; Insert enemy if needed
;=================================      
insertEnemy:
      lda  enemy                  ; test if there is an enemy to add in this column
      beq  noEnemy                 
      
      ldx  #1      
loopSearch:      
      lda  actType,x
      beq  freeSprite
      
      inx
      cpx  #8                     ; don't add an enemy if there are all sprite enabled
      beq  noEnemy
      bne  loopSearch
            
freeSprite:
      inc  actType,x              ; this actor is now to enable
      
      lda  #1                     ; insert fix position for x
      sta  xActHi,x
      lda  #72
      sta  xActLo,x
      
      lda  enemy                  ; insert the correct y position
      clc
      adc  #5                     ; for 4 lines of scores + 1
      asl 
      asl
      asl
      sta  yAct,x       
            
      lda  #0
      sta  enemy                  ; enemy is added, so clear status
           
      lda  #253
      sta  xActSpeed,x
noEnemy      
      rts 
    
;=================================
; Remove one enemy if it goes 
; out of left screen
;=================================            
removeEnemy:
      ldx  #1    
loopRemove:  
      lda  xActHi,x
      bne  skipLo
      
      lda  xActLo,x
      cmp  #15
      bcs  skipLo
      
      lda  #0                      
      sta  actType,x              ; remove this actor
      
skipLo:    
      inx
      cpx  #8
      bne  loopRemove
      rts

;=================================
; Move the monsters
;=================================            
moveMonster:
      lda flipflopwait
      eor #$01
      sta flipflopwait
      beq forceret

      ldx  #7
      
      lda  actType,x
      beq  moveNext
loopMovMon:      
      lda  xActSpeed,x
      bmi  negTest
      
      jsr  checkDx                ; test for a dx collision
      bcs  changeDir              ; if so change direction
      bcc  grCheck
      
negTest:
      jsr  checkSx                ; test for a sx collision
      bcs  changeDir              ; if so change direction
        
grCheck:                          ; check for ground under the monster 
      jsr  checkGround              
      bcs  moving                 ; change direction if there is no ground
      
      
changeDir:                        ; change the direction of monster  
      lda  xActSpeed,x
      eor  #$FF
      sec
      adc  #00                    ; complement 1
      sta  xActSpeed,x

moving:      
      jsr  moveActorX
      ;jsr moveActorY             ;  don't move monsters in y           

moveNext:      
      dex
      bne  loopMovMon
forceret:      
      rts   
      
flipflopwait:
 .byte 00   
    
;=================================
; Check enemy collision
;=================================     
checkEnemy:
      lda  $D01E                  ; read sprite/sprite collision
      beq  noCollision
                                  ; it is supposed that 2 monsters cannot collide, so map must be created carefully
      sta  temp1                            
      ldx  #7
                
loopCheck:      
      lda  temp1
      and  bitTable,x
      beq  noColl                  
 
      lda  jump
      cmp  #2                     ; is Sara falling 
      beq  monstKill              ; so the monster died
      
actKill:                          ; actor is died      
      lda  #1
      sta  status
      rts
      
monstKill:
      lda  yActSpeed
      cmp  #4                     ; test if we have enought speed for killing the enemy
      bcc  actKill
 
      lda  #MONSPOINT
      jsr  addScore               ; add this points for having killed a monster
      
      ;lda  #0
      ;sta  actType,x             ; the monster is disabled (this not work correctly)
      
      txa
      asl
      tay
      lda  #0
      sta  actType,x
      ;sta  $d000,y; position the current X sprite at 0,0 (invisible anyway?)
      sta  $d001,y      
      rts      
      
noColl:
      dex
      bne  loopCheck      
      
noCollision:       
      rts   

; input a=$12 output x= $31 "1" a= $32 "2"
atoax:
      pha                      ; save A for lo-nibble fetch
      lsr
      lsr
      lsr
      lsr
      ora  #$30
      tax
      pla                      ;lo-nibble fetch
      and  #$0F
      ora  #$30
      rts      
            
;==================================
; play music, set IRQ1, set graphics
; for scroll
;==================================
irqR0: 
      lda  xScroll
      and  #$07
      ora  #$10
      sta  $D016                 ; set scroll for x as needed  

      ldx  #1              
      stx  $d019                 ; acknowledge the raster interrupt
      lda  #<irqR1
      sta  $0314
      lda  #>irqR1
      sta  $0315      
      lda  #RASTER1
      sta  $D012                 ; Reading/Writing IRQ balance value                  
      
      lda  jumpDelay
      beq  pMusic
       
      dec  jumpDelay             ; decrease the delay for next jump    
pMusic:      
      ;jsr  $1003 ;playMusic
      jsr  $1100

      jmp  $ea81 
      
;=================================      
; set IRQ0, set graphics for title
; screen, let performs scrolling
;=================================
irqR1: 
      ldx  #1              
      stx  $d019                  ; acknowledge the raster interrupt   
        
      lda  #<irqR0
      sta  $0314

      lda  #$00 
      sta  $D016                  ; set not scroll for x (here it did not get flickers)               
      
      lda  #>irqR0
      sta  $0315      
      lda  #RASTER0
      sta  $D012                  ; Reading/Writing IRQ balance value      
          
      lda  #1
      sta  GO
  
      jmp  $ea81
      
        